<script setup lang="ts">
import { useRouter, useRoute } from 'vue-router';
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { ProModal } from 'antdv-pro-modal';
import { message, Modal, Form } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/es/table';
import {
  exportRole,
  addRole,
  changeRoleStatus,
  dataScope,
  delRole,
  getRole,
  listRole,
  updateRole,
} from '@/api/system/role';
import { menuTreeSelectRole, menuTreeSelect } from '@/api/system/menu';
import { deptTreeRole } from '@/api/system/dept';
import { saveAs } from 'file-saver';
import { parseDateToStr } from '@/utils/date-utils';
import useDictStore from '@/store/modules/dict';
import { DataNode } from 'ant-design-vue/es/tree';
import {
  parseTreeKeys,
  parseTreeNodeKeys,
  parseTreeNodeKeysByChecked,
} from '@/utils/parse-tree-utils';
import { hasPermissions } from '@/plugins/auth-user';
import { MENU_PATH_INLINE } from '@/constants/menu-constants';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useI18n from '@/hooks/useI18n';
import useUserStore from '@/store/modules/user';
const { t } = useI18n();
const { getDict } = useDictStore();
const userStore = useUserStore();
const router = useRouter();
const route = useRoute();
const routePath = route.path;

/**字典数据 */
let dict: {
  /**状态 */
  sysNormalDisable: DictType[];
} = reactive({
  sysNormalDisable: [],
});

/**开始结束时间 */
let queryRangePicker = ref<[string, string]>(['', '']);

/**查询参数 */
let queryParams = reactive({
  /**角色名称 */
  roleName: '',
  /**角色键值 */
  roleKey: '',
  /**角色状态 */
  statusFlag: undefined,
  /**记录开始时间 */
  beginTime: '',
  /**记录结束时间 */
  endTime: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    roleName: '',
    roleKey: '',
    statusFlag: undefined,
    beginTime: '',
    endTime: '',
    pageNum: 1,
    pageSize: 20,
  });
  queryRangePicker.value = ['', ''];
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: false,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('views.system.role.roleId'),
    dataIndex: 'roleId',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.system.role.roleName'),
    dataIndex: 'roleName',
    align: 'left',
    width: 200,
  },
  {
    title: t('views.system.role.roleKey'),
    dataIndex: 'roleKey',
    align: 'left',
    width: 200,
  },
  {
    title: t('views.system.role.roleSort'),
    dataIndex: 'roleSort',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.system.role.roleStatus'),
    dataIndex: 'statusFlag',
    key: 'statusFlag',
    align: 'center',
    width: 100,
  },
  {
    title: t('views.system.role.createTime'),
    dataIndex: 'createTime',
    align: 'center',
    width: 200,
    customRender(opt) {
      if (+opt.value <= 0) return '';
      return parseDateToStr(+opt.value);
    },
  },
  {
    title: t('common.operate'),
    key: 'roleId',
    align: 'left',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**表格多选 */
function fnTableSelectedRowKeys(keys: (string | number)[]) {
  tableState.selectedRowKeys = keys;
}

/**数据范围选项 */
const dataScopeOptions = ref<{ value: string; label: string }[]>([
  { value: '1', label: t('views.system.role.allScopeOptions') },
  { value: '2', label: t('views.system.role.byMyselfScopeOptions') },
  { value: '3', label: t('views.system.role.onlyClassScopeOptions') },
  { value: '4', label: t('views.system.role.classAllScopeOptions') },
  { value: '5', label: t('views.system.role.myselfScopeOptions') },
]);

type TreeDataType = {
  /**树结构数据 */
  treeData: DataNode[];
  /**选中复选框的树节点 */
  checkedKeys: string[] | number[];
  /**展开指定的树节点 */
  expandedKeys: string[] | number[];
};

/**初始菜单树数据 */
let menuTree: TreeDataType = {
  treeData: [],
  checkedKeys: [],
  expandedKeys: [],
};

/**初始部门树数据 */
let deptTree: TreeDataType = {
  treeData: [],
  checkedKeys: [],
  expandedKeys: [],
};

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**详情框是否显示 */
  openByView: boolean;
  /**新增框或修改框是否显示 */
  openByEdit: boolean;
  /**分配角色数据权限修改框是否显示 */
  openByDataScope: boolean;
  /**标题 */
  title: string;
  /**表单数据 */
  from: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
  /**菜单树结构 */
  menuTree: TreeDataType;
  /**部门树结构 */
  deptTree: TreeDataType;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  openByView: false,
  openByEdit: false,
  openByDataScope: false,
  title: '角色',
  from: {
    roleId: undefined,
    roleName: '',
    roleKey: '',
    roleSort: 0,
    statusFlag: '0',
    menuIds: [],
    deptIds: [],
    remark: '',
    dataScope: '5',
    deptCheckStrictly: '1',
    menuCheckStrictly: '1',
    createTime: 0,
  },
  confirmLoading: false,
  menuTree: {
    treeData: [],
    checkedKeys: [],
    expandedKeys: [],
  },
  deptTree: {
    treeData: [],
    checkedKeys: [],
    expandedKeys: [],
  },
});

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    roleName: [
      {
        required: true,
        min: 1,
        max: 30,
        message: t('views.system.role.trueValue', {
          msg: t('views.system.role.roleName'),
        }),
      },
    ],
    roleKey: [
      {
        required: true,
        min: 1,
        max: 50,
        message: t('views.system.role.trueValue', {
          msg: t('views.system.role.roleKey'),
        }),
      },
    ],
  })
);

/**
 * 对话框弹出显示为 查看
 * @param roleId 角色编号ID
 */
function fnModalVisibleByVive(roleId: string | number) {
  if (!roleId) {
    message.error(t('common.getInfoFail'), 2);
    return;
  }
  if (modalState.confirmLoading) return;
  const hide = message.loading(t('common.loading'), 0);
  modalState.confirmLoading = true;
  // 查询角色详细同时根据角色ID查询菜单下拉树结构
  Promise.all([getRole(roleId), menuTreeSelectRole(roleId)]).then(resArr => {
    modalState.confirmLoading = false;
    hide();
    if (resArr[0].code === RESULT_CODE_SUCCESS && resArr[0].data) {
      modalState.from = Object.assign(modalState.from, resArr[0].data);
      if (resArr[1].code === RESULT_CODE_SUCCESS && resArr[1].data) {
        const { menus, checkedKeys } = resArr[1].data;
        menuTree.checkedKeys = parseTreeKeys(menus, 'id');
        menuTree.expandedKeys = parseTreeNodeKeys(menus, 'id');
        menuTree.treeData = menus;
        modalState.menuTree.treeData = menus;
        modalState.menuTree.checkedKeys = checkedKeys;
        if (modalState.from.menuCheckStrictly === '1') {
          const ids = parseTreeNodeKeysByChecked(menus, checkedKeys, 'id');
          modalState.from.menuIds = ids.concat(checkedKeys);
        } else {
          modalState.from.menuIds = checkedKeys;
        }
      }
      modalState.title = t('views.system.role.roleInfo');
      modalState.openByView = true;
    } else {
      message.error(t('common.getInfoFail'), 2);
    }
  });
}

/**
 * 对话框弹出显示为 新增或者修改
 * @param roleId 角色编号ID, 不传为新增
 */
function fnModalVisibleByEdit(roleId?: string | number) {
  if (!roleId) {
    modalStateFrom.resetFields();
    if (menuTree.treeData.length > 0) {
      modalState.menuTree.treeData = menuTree.treeData;
      modalState.title = t('common.addText') + t('views.system.role.roleInfo');
      modalState.openByEdit = true;
    } else {
      if (modalState.confirmLoading) return;
      const hide = message.loading(t('common.loading'), 0);
      modalState.confirmLoading = true;
      // 查询菜单下拉树结构
      menuTreeSelect().then(res => {
        modalState.confirmLoading = false;
        hide();
        if (res.code === RESULT_CODE_SUCCESS) {
          menuTree.checkedKeys = parseTreeKeys(res.data, 'id');
          menuTree.expandedKeys = parseTreeNodeKeys(res.data, 'id');
          menuTree.treeData = res.data;
          modalState.menuTree.treeData = res.data;
          modalState.title =
            t('common.addText') + t('views.system.role.roleInfo');
          modalState.openByEdit = true;
        }
      });
    }
  } else {
    if (modalState.confirmLoading) return;
    const hide = message.loading(t('common.loading'), 0);
    modalState.confirmLoading = true;
    // 查询角色详细同时根据角色ID查询菜单下拉树结构
    Promise.all([getRole(roleId), menuTreeSelectRole(roleId)]).then(resArr => {
      modalState.confirmLoading = false;
      hide();
      if (resArr[0].code === RESULT_CODE_SUCCESS && resArr[0].data) {
        modalState.from = Object.assign(modalState.from, resArr[0].data);
        if (resArr[1].code === RESULT_CODE_SUCCESS && resArr[1].data) {
          const { menus, checkedKeys } = resArr[1].data;
          menuTree.checkedKeys = parseTreeKeys(menus, 'id');
          menuTree.expandedKeys = parseTreeNodeKeys(menus, 'id');
          menuTree.treeData = menus;
          modalState.menuTree.treeData = menus;
          modalState.menuTree.checkedKeys = checkedKeys;
          if (modalState.from.menuCheckStrictly === '1') {
            const ids = parseTreeNodeKeysByChecked(menus, checkedKeys, 'id');
            modalState.from.menuIds = ids.concat(checkedKeys);
          } else {
            modalState.from.menuIds = checkedKeys;
          }
        }
        modalState.title =
          t('common.editText') + t('views.system.role.roleInfo');
        modalState.openByEdit = true;
      } else {
        message.error(t('common.getInfoFail'), 2);
      }
    });
  }
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  modalStateFrom
    .validate()
    .then(() => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.from);
      const role = from.roleId ? updateRole(from) : addRole(from);
      const key = 'role';
      message.loading({ content: t('common.loading'), key });
      role
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              key,
              duration: 2,
            });
            modalState.openByEdit = false;
            modalStateFrom.resetFields();
            fnGetList(1);
          } else {
            message.error({
              content: `${res.msg}`,
              key,
              duration: 2,
            });
          }
        })
        .finally(() => {
          modalState.confirmLoading = false;
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.openByEdit = false;
  modalState.openByView = false;
  modalState.openByDataScope = false;
  modalStateFrom.resetFields();
  modalState.menuTree.checkedKeys = [];
  modalState.menuTree.expandedKeys = [];
  modalState.deptTree.checkedKeys = [];
  modalState.deptTree.expandedKeys = [];
}

/**
 * 对话框表单树勾选事件
 */
function fnModalTreeChecked(keys: any, info: any, type: 'menu' | 'dept') {
  let ids = Array.isArray(keys) ? keys : keys.checked;
  if (type === 'menu') {
    if (modalState.from.menuCheckStrictly === '1') {
      ids = ids.concat(info.halfCheckedKeys);
    }
    modalState.from.menuIds = ids;
  }
  if (type === 'dept') {
    if (modalState.from.deptCheckStrictly === '1') {
      ids = ids.concat(info.halfCheckedKeys);
    }
    modalState.from.deptIds = ids;
  }
}

/**
 * 对话框表单树（展开/折叠）事件
 */
function fnModalExpandedKeys(checked: boolean, type: 'menu' | 'dept') {
  if (type === 'menu') {
    modalState.menuTree.expandedKeys = checked ? menuTree.expandedKeys : [];
  }
  if (type === 'dept') {
    modalState.deptTree.expandedKeys = checked ? deptTree.expandedKeys : [];
  }
}

/**
 * 对话框表单树（全选/全不选）事件
 */
function fnModalCheckedKeys(checked: boolean, type: 'menu' | 'dept') {
  if (type === 'menu') {
    modalState.menuTree.checkedKeys = checked ? menuTree.checkedKeys : [];
    modalState.from.menuIds = modalState.menuTree.checkedKeys;
  }
  if (type === 'dept') {
    modalState.deptTree.checkedKeys = checked ? deptTree.checkedKeys : [];
    modalState.from.deptIds = modalState.deptTree.checkedKeys;
  }
}

/**
 * 对话框表单树（父子联动）事件
 */
function fnModalCheckStrictly(checked: boolean, type: 'menu' | 'dept') {
  if (type === 'menu') {
    modalState.from.menuCheckStrictly = checked ? '1' : '0';
  }
  if (type === 'dept') {
    modalState.from.deptCheckStrictly = checked ? '1' : '0';
  }
}

/**
 * 对话框弹出分配数据权限确认执行函数
 */
function fnModalOkDataScope() {
  if (modalState.confirmLoading) return;
  modalState.confirmLoading = true;
  const hide = message.loading(t('common.loading'), 0);
  const fromInfo = toRaw(modalState.from);
  if (fromInfo.dataScope !== '2') {
    fromInfo.deptIds = [];
  }
  dataScope(fromInfo)
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS) {
        message.success({
          content: t('common.msgSuccess', { msg: modalState.title }),
          duration: 2,
        });
        modalState.openByDataScope = false;
        modalStateFrom.resetFields();
      } else {
        message.error({
          content: `${res.msg}`,
          duration: 2,
        });
      }
    })
    .finally(() => {
      hide();
      modalState.confirmLoading = false;
    });
}

/**
 * 角色分配数据权限
 * @param roleId 角色编号ID
 */
function fnRecordDataScope(roleId: string | number) {
  if (!roleId) {
    message.error(t('common.getInfoFail'), 2);
    return;
  }
  if (modalState.confirmLoading) return;
  const hide = message.loading(t('common.loading'), 0);
  modalState.confirmLoading = true;
  // 查询角色详细同时根据角色ID查询部门树结构
  Promise.all([getRole(roleId), deptTreeRole(roleId)])
    .then(resArr => {
      if (resArr[0].code === RESULT_CODE_SUCCESS && resArr[0].data) {
        modalState.from = Object.assign(modalState.from, resArr[0].data);
        if (resArr[1].code === RESULT_CODE_SUCCESS && resArr[1].data) {
          const { depts, checkedKeys } = resArr[1].data;
          deptTree.checkedKeys = parseTreeKeys(depts, 'id');
          deptTree.expandedKeys = parseTreeNodeKeys(depts, 'id');
          deptTree.treeData = depts;
          modalState.deptTree.treeData = depts;
          modalState.deptTree.checkedKeys = checkedKeys;
          if (modalState.from.deptCheckStrictly === '1') {
            const ids = parseTreeNodeKeysByChecked(depts, checkedKeys, 'id');
            modalState.from.deptIds = ids.concat(checkedKeys);
          } else {
            modalState.from.deptIds = checkedKeys;
          }
        }
        modalState.title = t('views.system.role.distribute');
        modalState.openByDataScope = true;
      } else {
        message.error(t('common.getInfoFail'), 2);
      }
    })
    .finally(() => {
      modalState.confirmLoading = false;
      hide();
    });
}

/**
 * 角色分配用户跳转
 * @param roleId 角色编号ID
 */
function fnRecordAuthUser(row: Record<string, string>) {
  router.push({
    path: `${routePath}${MENU_PATH_INLINE}/auth-user/${row.roleId}`,
    query: {
      roleName: row.roleName,
    },
  });
}

/**
 * 角色状态修改
 * @param row 角色记录对象
 */
function fnRecordStatus(row: Record<string, string>) {
  const text =
    row.statusFlag === '1'
      ? t('views.system.role.open')
      : t('views.system.role.close');
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.system.role.statusSure', {
      text: text,
      roleName: row.roleName,
    }),
    onOk() {
      const hide = message.loading(t('common.loading'), 0);
      changeRoleStatus(row.roleId, row.statusFlag).then(res => {
        hide();
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: `${row.roleName} ${text} ${t('common.msgSuccess')}`,
            duration: 2,
          });
        } else {
          message.error({
            content: t('views.system.role.statusSure', {
              text: text,
              roleName: row.roleName,
            }),
            duration: 2,
          });
        }
        fnGetList();
      });
    },
    onCancel() {
      row.statusFlag = row.statusFlag === '1' ? '0' : '1';
    },
  });
}

/**
 * 角色删除
 * @param roleId 角色编号ID
 */
function fnRecordDelete(roleId: string = '0') {
  if (roleId === '0') {
    roleId = tableState.selectedRowKeys.join(',');
  }
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.system.role.delSure', { roleId: roleId }),
    onOk() {
      const key = 'delRole';
      message.loading({ content: t('common.loading'), key });
      delRole(roleId).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.msgSuccess', { msg: t('common.deleteText') }),
            key,
            duration: 2,
          });
          fnGetList();
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**列表导出 */
function fnExportList() {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.system.user.exportSure'),
    onOk() {
      const key = 'exportRole';
      message.loading({ content: t('common.loading'), key });
      exportRole(toRaw(queryParams)).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.msgSuccess', {
              msg: t('views.system.user.export'),
            }),
            key,
            duration: 2,
          });
          saveAs(res.data, `role_${Date.now()}.xlsx`);
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**查询角色列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  if (!queryRangePicker.value) {
    queryRangePicker.value = ['', ''];
  }
  queryParams.beginTime = queryRangePicker.value[0];
  queryParams.endTime = queryRangePicker.value[1];
  listRole(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      const { total, rows } = res.data;
      tablePagination.total = total;
      tableState.data = rows;
      if (
        tablePagination.total <=
          (queryParams.pageNum - 1) * tablePagination.pageSize &&
        queryParams.pageNum !== 1
      ) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    }
    tableState.loading = false;
  });
}

onMounted(() => {
  // 初始字典数据
  Promise.allSettled([getDict('sys_normal_disable')]).then(resArr => {
    if (resArr[0].status === 'fulfilled') {
      dict.sysNormalDisable = resArr[0].value;
    }
  });
  // 获取列表数据
  fnGetList();
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleName')"
              name="roleName"
            >
              <a-input
                v-model:value="queryParams.roleName"
                allow-clear
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.system.role.roleKey')" name="roleKey">
              <a-input
                v-model:value="queryParams.roleKey"
                allow-clear
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="4" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleStatus')"
              name="statusFlag"
            >
              <a-select
                v-model:value="queryParams.statusFlag"
                allow-clear
                :options="dict.sysNormalDisable"
              >
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="8" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.createTime')"
              name="queryRangePicker"
            >
              <a-range-picker
                v-model:value="queryRangePicker"
                allow-clear
                bordered
                :show-time="{ format: 'HH:mm:ss' }"
                format="YYYY-MM-DD HH:mm:ss"
                value-format="x"
                style="width: 100%"
              ></a-range-picker>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-button
            type="primary"
            @click.prevent="fnModalVisibleByEdit()"
            v-perms:has="['system:role:add']"
          >
            <template #icon><PlusOutlined /></template>
            {{ t('common.addText') }}
          </a-button>
          <a-button
            type="default"
            danger
            :disabled="tableState.selectedRowKeys.length <= 0"
            @click.prevent="fnRecordDelete()"
            v-perms:has="['system:role:remove']"
          >
            <template #icon><DeleteOutlined /></template>
            {{ t('common.deleteText') }}
          </a-button>
          <a-button
            type="dashed"
            @click.prevent="fnExportList()"
            v-perms:has="['system:role:export']"
          >
            <template #icon><ExportOutlined /></template>
            {{ t('common.export') }}
          </a-button>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default"
                    >{{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle"
                    >{{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small"
                    >{{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="roleId"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: tableColumns.length * 120 }"
        :row-selection="{
          type: 'checkbox',
          selectedRowKeys: tableState.selectedRowKeys,
          onChange: fnTableSelectedRowKeys,
        }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'statusFlag'">
            <a-switch
              v-if="
                dict.sysNormalDisable.length > 0 &&
                record.roleId !== 1 &&
                !userStore.roles?.includes(record.roleKey) &&
                hasPermissions(['system:role:edit'])
              "
              v-model:checked="record.statusFlag"
              checked-value="1"
              :checked-children="dict.sysNormalDisable[0].label"
              un-checked-value="0"
              :un-checked-children="dict.sysNormalDisable[1].label"
              size="small"
              @change="fnRecordStatus(record)"
            />
            <DictTag
              v-else
              :options="dict.sysNormalDisable"
              :value="record.statusFlag"
            />
          </template>
          <template v-if="column.key === 'roleId'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.viewText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByVive(record.roleId)"
                  v-perms:has="['system:role:query']"
                >
                  <template #icon><ProfileOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip
                v-if="
                  record.roleId !== 1 &&
                  !userStore.roles?.includes(record.roleKey)
                "
              >
                <template #title>{{ t('common.editText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByEdit(record.roleId)"
                  v-perms:has="['system:role:edit']"
                >
                  <template #icon><FormOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip
                v-if="
                  record.roleId !== 1 &&
                  !userStore.roles?.includes(record.roleKey)
                "
              >
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordDelete(record.roleId)"
                  v-perms:has="['system:role:remove']"
                >
                  <template #icon><DeleteOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip placement="topRight" v-if="record.roleId !== 1">
                <template #title>{{
                  t('views.system.role.distribute')
                }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordDataScope(record.roleId)"
                  v-perms:has="['system:role:edit']"
                >
                  <template #icon><SecurityScanOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip placement="topRight" v-if="false">
                <template #title>{{
                  t('views.system.role.distributeUser')
                }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordAuthUser(record)"
                  v-perms:has="['system:role:auth']"
                >
                  <template #icon><TeamOutlined /></template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 详情框 -->
    <ProModal
      :drag="true"
      :width="800"
      :destroyOnClose="false"
      :open="modalState.openByView"
      :title="modalState.title"
      @cancel="fnModalCancel"
    >
      <a-form layout="horizontal" :label-col="{ span: 6 }" :label-wrap="true">
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item :label="t('views.system.role.roleId')" name="roleId">
              {{ modalState.from.roleId }}
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.createTime')"
              name="createTime"
            >
              <span v-if="+modalState.from.createTime > 0">
                {{ parseDateToStr(+modalState.from.createTime) }}
              </span>
            </a-form-item>
          </a-col>
        </a-row>
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleSort')"
              name="roleSort"
            >
              {{ modalState.from.roleSort }}
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleStatus')"
              name="statusFlag"
            >
              <DictTag
                :options="dict.sysNormalDisable"
                :value="modalState.from.statusFlag"
              />
            </a-form-item>
          </a-col>
        </a-row>
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleName')"
              name="roleName"
            >
              {{ modalState.from.roleName }}
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item :label="t('views.system.role.roleKey')" name="roleKey">
              {{ modalState.from.roleKey }}
            </a-form-item>
          </a-col>
        </a-row>
        <a-form-item
          :label="t('views.system.role.roleMark')"
          name="remark"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-textarea
            v-model:value="modalState.from.remark"
            :auto-size="{ minRows: 2, maxRows: 6 }"
            :disabled="true"
          />
        </a-form-item>

        <a-form-item
          :label="t('views.system.role.menu')"
          name="menuCheckStrictly"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-tree
            disabled
            checkable
            :selectable="false"
            v-model:expanded-keys="modalState.menuTree.expandedKeys"
            v-model:checked-keys="modalState.menuTree.checkedKeys"
            :check-strictly="modalState.from.menuCheckStrictly === '0'"
            :tree-data="modalState.menuTree.treeData"
            :field-names="{ children: 'children', title: 'label', key: 'id' }"
            :height="256"
            style="border: 1px solid #d9d9d9; margin-top: 4px"
          >
          </a-tree>
        </a-form-item>
      </a-form>
      <template #footer>
        <a-button key="cancel" @click="fnModalCancel">{{
          t('common.cancel')
        }}</a-button>
      </template>
    </ProModal>

    <!-- 新增框或修改框 -->
    <ProModal
      :drag="true"
      :width="800"
      :destroyOnClose="true"
      :keyboard="false"
      :mask-closable="false"
      :open="modalState.openByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form
        name="modalStateFromByEdit"
        layout="horizontal"
        :label-col="{ span: 6 }"
        :label-wrap="true"
      >
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleName')"
              name="roleName"
              v-bind="modalStateFrom.validateInfos.roleName"
            >
              <a-input
                v-model:value="modalState.from.roleName"
                allow-clear
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleStatus')"
              name="statusFlag"
            >
              <a-select
                v-model:value="modalState.from.statusFlag"
                default-value="0"
                :options="dict.sysNormalDisable"
              >
              </a-select>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleKey')"
              name="roleKey"
              v-bind="modalStateFrom.validateInfos.roleKey"
            >
              <a-input v-model:value="modalState.from.roleKey" allow-clear>
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      <div>
                        {{ t('views.system.role.roleKeyTip') }}
                      </div>
                    </template>
                    <InfoCircleOutlined style="opacity: 0.45; color: inherit" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleSort')"
              name="roleSort"
            >
              <a-input-number
                v-model:value="modalState.from.roleSort"
                :min="0"
                :max="65535"
                :step="1"
              ></a-input-number>
            </a-form-item>
          </a-col>
        </a-row>

        <a-form-item
          :label="t('views.system.role.roleMark')"
          name="remark"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-textarea
            v-model:value="modalState.from.remark"
            :auto-size="{ minRows: 4, maxRows: 6 }"
            :maxlength="450"
            :show-count="true"
          />
        </a-form-item>

        <a-form-item
          :label="t('views.system.role.menu')"
          name="menuCheckStrictly"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-space :size="12" align="center">
            <a-checkbox
              id="menu_1"
              :checked="modalState.menuTree.expandedKeys.length > 0"
              @change="(e:any) => fnModalExpandedKeys(e.target.checked, 'menu')"
            >
              {{ t('views.system.role.openSwitch') }}
            </a-checkbox>
            <a-checkbox
              id="menu_2"
              :checked="modalState.from.menuIds.length > 0"
              @change="(e:any) => fnModalCheckedKeys(e.target.checked, 'menu')"
            >
              {{ t('views.system.role.selAllSwitch') }}
            </a-checkbox>
            <a-checkbox
              id="menu_3"
              :checked="modalState.from.menuCheckStrictly === '1'"
              @change="(e:any) => fnModalCheckStrictly(e.target.checked, 'menu')"
            >
              {{ t('views.system.role.relationSwitch') }}
            </a-checkbox>
          </a-space>
          <a-tree
            checkable
            :selectable="false"
            @check="
              (checked:any, info:any) => fnModalTreeChecked(checked, info, 'menu')
            "
            v-model:expanded-keys="modalState.menuTree.expandedKeys"
            v-model:checked-keys="modalState.menuTree.checkedKeys"
            :check-strictly="modalState.from.menuCheckStrictly === '0'"
            :tree-data="modalState.menuTree.treeData"
            :field-names="{ children: 'children', title: 'label', key: 'id' }"
            :height="256"
            style="border: 1px solid #d9d9d9; margin-top: 4px"
          >
          </a-tree>
        </a-form-item>
      </a-form>
    </ProModal>

    <!-- 分配角色数据权限修改框 -->
    <ProModal
      :drag="true"
      :width="800"
      :destroyOnClose="true"
      :keyboard="false"
      :mask-closable="false"
      :open="modalState.openByDataScope"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOkDataScope"
      @cancel="fnModalCancel"
    >
      <a-form
        name="modalStateFromByDataScope"
        layout="horizontal"
        :label-col="{ span: 6 }"
        :label-wrap="true"
      >
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item :label="t('views.system.role.roleId')" name="roleId">
              {{ modalState.from.roleId }}
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.createTime')"
              name="createTime"
            >
              <span v-if="+modalState.from.createTime > 0">
                {{ parseDateToStr(+modalState.from.createTime) }}
              </span>
            </a-form-item>
          </a-col>
        </a-row>
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleSort')"
              name="roleSort"
            >
              {{ modalState.from.roleSort }}
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleStatus')"
              name="statusFlag"
            >
              <DictTag
                :options="dict.sysNormalDisable"
                :value="modalState.from.statusFlag"
              />
            </a-form-item>
          </a-col>
        </a-row>
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleName')"
              name="roleName"
            >
              {{ modalState.from.roleName }}
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item :label="t('views.system.role.roleKey')" name="roleKey">
              {{ modalState.from.roleKey }}
            </a-form-item>
          </a-col>
        </a-row>
        <a-form-item
          :label="t('views.system.role.roleMark')"
          name="remark"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-textarea
            v-model:value="modalState.from.remark"
            :auto-size="{ minRows: 2, maxRows: 6 }"
            :disabled="true"
          />
        </a-form-item>

        <a-form-item
          :label="t('views.system.role.preScope')"
          name="dataScope"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-select
            v-model:value="modalState.from.dataScope"
            default-value="5"
            :options="dataScopeOptions"
          >
          </a-select>
        </a-form-item>
        <a-form-item
          :label="t('views.system.role.dataPer')"
          name="deptCheckStrictly"
          :label-col="{ span: 3 }"
          :label-wrap="true"
          v-show="modalState.from.dataScope === '2'"
        >
          <a-space :size="12" align="center">
            <a-checkbox
              id="dept_1"
              :checked="modalState.deptTree.expandedKeys.length > 0"
              @change="(e:any) => fnModalExpandedKeys(e.target.checked, 'dept')"
            >
              {{ t('views.system.role.openSwitch') }}
            </a-checkbox>
            <a-checkbox
              id="dept_2"
              :checked="modalState.from.deptIds.length > 0"
              @change="(e:any) => fnModalCheckedKeys(e.target.checked, 'dept')"
            >
              {{ t('views.system.role.selAllSwitch') }}
            </a-checkbox>
            <a-checkbox
              id="dept_1"
              :checked="modalState.from.deptCheckStrictly === '1'"
              @change="(e:any) => fnModalCheckStrictly(e.target.checked, 'dept')"
            >
              {{ t('views.system.role.relationSwitch') }}
            </a-checkbox>
          </a-space>
          <a-tree
            checkable
            :selectable="false"
            @check="
              (checked:any, info:any) => fnModalTreeChecked(checked, info, 'dept')
            "
            v-model:expanded-keys="modalState.deptTree.expandedKeys"
            v-model:checked-keys="modalState.deptTree.checkedKeys"
            :check-strictly="modalState.from.deptCheckStrictly === '0'"
            :tree-data="modalState.deptTree.treeData"
            :field-names="{ children: 'children', title: 'label', key: 'id' }"
            :height="256"
            style="border: 1px solid #d9d9d9; margin-top: 4px"
          >
          </a-tree>
        </a-form-item>
      </a-form>
    </ProModal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
